<template>
	<view class="uni-countdown">
		<view v-if="showDay" class="uni-countdown__number" :style="{borderColor:borderColor, color:color, background:backgroundColor}">{{d}}</view>
		<view v-if="showDay" class="uni-countdown__splitor" :style="{color:splitorColor}">天</view>
		<view class="uni-countdown__number" :style="{borderColor:borderColor, color:color, background:backgroundColor}">{{h}}</view>
		<view class="uni-countdown__splitor" :style="{color:splitorColor}">{{showColon ? ':' : '时'}}</view>
		<view class="uni-countdown__number" :style="{borderColor:borderColor, color:color, background:backgroundColor}">{{i}}</view>
		<view class="uni-countdown__splitor" :style="{color:splitorColor}">{{showColon ? ':' : '分'}}</view>
		<view class="uni-countdown__number" :style="{borderColor:borderColor, color:color, background:backgroundColor}">{{s}}</view>
		<view v-if="!showColon" class="uni-countdown__splitor" :style="{color:splitorColor}">秒</view>
	</view>
</template>
<script>
	export default {
		name: "uni-countdown",
		props: {
			showColon: {
				type: Boolean,
				default: true
			},
			backgroundColor: {
				type: String,
				default: "inherit"
			},
			borderColor: {
				type: String,
				default: "#000000"
			},
			color: {
				type: String,
				value: "#000000"
			},
			splitorColor: {
				type: String,
				default: "#000000"
			},
			dateTime: {
				type: String,
				default: new Date()._format('yyyy/MM/dd')
			}
		},
		data() {
			return {
				timer: null,
				d: '00',
				h: '00',
				i: '00',
				s: '00',
				ms: 0,
				leftTime: 0,
				seconds: 0,
				showDay: true
			}
		},
		created: function(e) {
			this.countDown()
			this.timer = setInterval(() => {
				this.seconds--
				if (this.seconds < 0) {
					this.timeUp()
					return
				}
				this.countDown()
			}, 1000)
		},
		beforeDestroy() {
			clearInterval(this.timer)
		},
		methods: {
			timeUp() {
				clearInterval(this.timer)
				this.$emit('timeup')
			},
			countDown() {
				let [day, hour, minute, second, millisecond] = [0, 0, 0, 0, 0]
				if (this.dateTime) {
					this.seconds = new Date(this.dateTime).getTime() - new Date().getTime()
					day = Math.floor(this.seconds / (1000 * 60 * 60 * 24))
					hour = Math.floor(this.seconds / (1000 * 60 * 60)) - (day * 24)
					minute = Math.floor(this.seconds / (1000 * 60)) - (day * 24 * 60) - (hour * 60)
					second = Math.floor(this.seconds / 1000) - (day * 24 * 60 * 60) - (hour * 60 * 60) - (minute * 60)
				} else this.timeUp()
				if (day && day < 10) day = '0' + day
				else if (day == 0) this.showDay = false
				if (hour < 10) hour = '0' + hour
				if (minute < 10) minute = '0' + minute
				if (second < 10) second = '0' + second
				this.d = day
				this.h = hour
				this.i = minute
				this.s = second
			}
		}
	}
</script>
<style>
	@charset "UTF-8";

	.uni-countdown {
		padding: 2upx 0;
		display: inline-flex;
		flex-wrap: nowrap;
		justify-content: center
	}

	.uni-countdown__splitor {
		justify-content: center;
		line-height: 44upx;
		padding: 0 10upx
	}

	.uni-countdown__number {
		line-height: 44upx;
		justify-content: center;
		height: 44upx;
	}
</style>